<template>
  <div id="page" class="common-layout">
    <el-container>
      <el-aside width="50%">
        <el-row style="height:250px">

        </el-row>
        <el-row>
          <el-col></el-col>
          <el-col>
            <h1 style="font-size:4ex">同济大学</h1>
          </el-col>
          <el-col></el-col>
          
        </el-row>
        <el-row>
          <el-col></el-col>
          <el-col>
            <h1 style="font-size:4ex">德育分管理系统</h1>
          </el-col>
          <h1></h1>
        </el-row>
        <el-row>
          
        </el-row>
      </el-aside>

      <el-main>
        <el-row style="height:140px"></el-row>
        <el-row>
            <div id="loginForm">
                <el-form v-if="frame==1">
                    <el-form-item label="邮箱">
                      <el-input type="email" pattern="^\d*@tongji.edu.cn" v-model="lemail" required/>
                    </el-form-item>
                    <el-form-item label="密码">
                      <el-input type="password" v-model="lpassword" required autocomplete="off" />
                    </el-form-item>
                    <el-form-item>
                      <el-button class="login" type="success" size="large" @click="login">登录</el-button> 
                    </el-form-item>
                    <el-form-item class="link">
                      <a href="#" @click="frame=3" style="position:relative;right:10px">忘记密码</a>
                      <a href="#" @click="frame=2" style="position:relative;left:10px">注册账号</a>
                    </el-form-item>
                </el-form>

                <el-form v-if="frame==2" label-width="100px" style="position:relative;top:30px;">
                    <el-form-item label="昵称:">
                      <el-input type="text" v-model="name" autocomplete="off" required/>
                    </el-form-item>
                    <el-form-item label="邮箱:" v-if="way">
                      <el-input type="email" v-model="email" pattern="^\d*@tongji.edu.cn"/>
                    </el-form-item>
                    <el-form-item label="手机号:" v-if="!way">
                      <el-input type="number" v-model="mobile" autocomplete="off"/>
                    </el-form-item>
                    <el-form-item label="验证码:">
                      <el-input type="text" v-model="authcode" autocomplete="off"
                        style="width:100px" required/>
                      <el-button id="authBtn" @click="sendCode" type="primary"
                        style="position:relative;left:10px;width:90px">发送验证码</el-button>
                    </el-form-item>
                    <el-form-item label="密码:">
                      <el-input type="password" autocomplete="off" v-model="password" required/>
                    </el-form-item>
                    <el-form-item label="再次输入密码:">
                      <el-input type="password" autocomplete="off" v-model="password2" required/>
                    </el-form-item>
                    <el-form-item>
                      <el-button class="register" type="submit" size="large" 
                        id="registerBtn" @click="register">注册</el-button>
                    </el-form-item>
                    <el-form-item class="link2">
                      <!-- <a href="#" v-if="way" @click="way=!way" style="position:relative;left:40px">手机号注册</a> -->
                      <a href="#" v-if="!way" @click="way=!way" style="position:relative;left:40px">邮箱注册</a>
                      <a href="#" @click="frame=1" style="position:relative;right:10px">已有账号？返回登录</a>
                    </el-form-item>
                </el-form>

                <el-form v-if="frame==3" label-width="100px" style="position:relative;top:10px;">
                    <el-form-item label="邮箱:" v-if="way">
                      <el-input type="email" v-model="email" pattern="^\d*@tongji.edu.cn"/>
                    </el-form-item>
                    <el-form-item label="验证码:">
                      <el-input type="text" v-model="authcode" autocomplete="off"
                        style="width:100px" required/>
                      <el-button id="authBtn" @click="forgetPwd" type="primary"
                        style="position:relative;left:10px;width:90px;">发送验证码</el-button>
                    </el-form-item>
                    <el-form-item label="新密码:">
                      <el-input type="password" autocomplete="off" v-model="password" required/>
                    </el-form-item>
                    <el-form-item label="再次输入密码:">
                      <el-input type="password" autocomplete="off" v-model="password2" required/>
                    </el-form-item>
                    <el-form-item>
                      <el-button class="register" type="success" size="large" 
                        @click="resetPwd">重置密码</el-button>
                        
                    </el-form-item>
                    <a href="#" @click="frame=1">返回登录页面</a>
                </el-form>

            </div>
        </el-row>
        <el-row></el-row>
          
      </el-main>
    </el-container>
  </div>
    


</template>

<script>
import axios from "axios";
import global from "./Common.vue";
axios.defaults.withCredentials = true;
export default {
    name:"LoginRegister",
    data() {
      return {
            frame:1,
            way:1,
            lemail:"",
            lpassword:"",
            name:"",
            email:"",
            mobile:"",
            authcode:"",
            password:"",
            password2:"",
            agree:0,
            ip:global.ip
        }
    },
    watch:{
        way(){
            this.name="",
            this.email="",
            this.authcode="",
            this.password="",
            this.password2=""
        }
    },
    methods:{
        login(){
            axios({
                method:'POST',
                url:"http://"+this.ip+"/api/user/login",
                data:{
                    email:this.lemail,
                    password:this.lpassword,
                }
            }).then(function(res){
                console.log(res);
                if(res.data.code=="00"){
                  const { author, token } = res.data
                  localStorage.setItem("token", token)
                  localStorage.setItem("author", author)
                  window.location.replace("http://" + global.ip_front + "/profile");
                  console.log(global.ip_front);
                }
                else{
                  alert(res.data.msg)
                } 
            });
        },
        sendCode(){
            axios({
                method:'POST',
                url:"http://"+this.ip+"/api/user/mailcode",
                data:{
                    name:this.name,
                    email:this.email
                }
            }).then(function(res){
                alert(res.data.msg)
                console.log(res)
            })
        },
        register(){
            if(this.password==this.password2)
                axios({
                    method:'POST',
                    url:"http://"+this.ip+"/api/user/register",
                    data:{
                        name:this.name,
                        email:this.email,
                        authcode: this.authcode,
                        password: this.password
                    }
                }).then(function(res){
                    alert(res.data.msg)
                    console.log(res)
                    if(res.data.code=="00")
                      window.location.replace("http://" + global.ip_front + "/profile");
                      
                })
        },
        forgetPwd(){
            if(this.email==""){
              alert("请输入邮箱");
            }
            else{
              alert("重置密码链接已发送至你的邮箱!");
              axios({
                  method:'POST',
                  url:"http://"+this.ip+"/api/user/forgetpwd",
                  data:{
                      email:this.email
                  }
              }).then(function(res){
                  console.log(res)
              })
            }
        },
        resetPwd(){
          if(this.email!=""&&this.password!=""&&this.authcode!=""){
            axios({
              method: "POST",
              url:"http://"+this.ip+"/api/user/setpwd",
              data:{
                email:this.email,
                password: this.password,
                authcode: this.authcode
              }
            }).then((res)=>{
              alert(res.data.msg);
            })
          }
        }
    },
    created() {
      console.log(this.$route)
      let _frame = this.$route.query.frame
      if (_frame) this.frame = _frame
    }
}
</script>


<style scoped>

#page{
  position: absolute;
  width: 100%;
  height: 100%;
}

#loginForm{
    display: flex;
    justify-content: center;
    align-items: center;
    height: 50vh;
    background-color: white;
    width: 400px;
    top:20%;
    left:5%;
    border-radius: 8px;
    padding: 20px 40px;
    box-shadow: 0 10px 25px rgba(92, 99, 105, .2);
}

.login{
  position: relative;
  left: 70px;
  top: 10px;
}

.register{
  position: relative;
  left:50px
}

.link{
  position: relative;
  left: 40px;
  top: 20px;
}

.link2{
  position: relative;
  left:20px;
}

.el-container{
  position: absolute;
  width: 100%;
  height: 100%;
}
#registerBtn{
    display: block;
    width:120px;
    background-color: rgb(37, 208, 63);
    padding: 6px 40px;
    color: white;
    border-radius: 6px;
    font-size: 16px;
    cursor: pointer;
    position:relative;
    left:30px;
}
#registerBtn:hover {
  background-color: #9867C5;
  transform: translateY(-2px);
}
</style>